<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 7.7: Line Input and Output</title>
<link href="sx10f.html" rev=precedes>
<link href="sx10h.html" rel=precedes>
<link href="sx10.html" rev=subdocument>
</head>
<body>
<H2>section 7.7: Line Input and Output</H2>

pages 164-165
<p>To summarize,
<TT>puts</TT> is like <TT>fputs</TT>
except that the stream is assumed to be the standard output (<TT>stdout</TT>),
<em>and</em> a newline (<TT>'\n'</TT>) is automatically appended.
<TT>gets</TT> is like <TT>fgets</TT>
except that the stream is assumed to be <TT>stdin</TT>,
and the newline (<TT>'\n'</TT>) is deleted,
<em>and</em> there's no way to specify the maximum line length.
This last fact means that
you
almost never
want
to use <TT>gets</TT>
at all:
since you can't tell it how big the array it's to read into is,
there's no way to guarantee
that some unexpectedly-long input line
won't overflow the array,
with dire results.
(When discussing the drawbacks of <TT>gets</TT>,
it's customary to point out that the ``Internet worm,''
a program that wreaked havoc in 1988
by breaking into computers all over the net,
was able to do so
in part
because a key network utility
on many Unix systems
used <TT>gets</TT>,
and
the worm was able to overflow the buffer
in a particularly low, cunning way,
with the dire result that
the worm achieved superuser access to the attacked machine.)
<br></p><hr>
<p>
Read sequentially:
<a href="sx10f.html" rev=precedes>prev</a>
<a href="sx10h.html" rel=precedes>next</a>
<a href="sx10.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
